<?php

require_once 'common_functions.php';
require_once "fs_lang.php";
require_once 'generate_common.php';

function GetRedirectCfg()
{
    global $start_up_redirect_option, $start_up_redirect_url, $start_up_redirect_wait, $wait_time, $value;
    
    // create COM Object
    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("redirect.php FSCONFIG.Cfgmgr Object cannot be created!");
    $start_up_redirect_option = $settingobj->getKey("start_up_redirect_option", "gateway");
    $start_up_redirect_url = $settingobj->getKey('start_up_redirect_url', 'gateway');	  
    $start_up_redirect_wait = $settingobj->getKey("start_up_redirect_wait", "gateway");
    $wait_time = $start_up_redirect_wait * 1000;
	$show_infobox = $settingobj->getKey("show_infobox", "gateway");
	$not_support_popup_option = $settingobj->getKey("not_support_popup_option", "gateway");

    if ( checking_ua($_SERVER['HTTP_USER_AGENT']) == 1 && strtolower($show_infobox) == "on" && $not_support_popup_option == 1){ // contain mobile token on client ua and set "Redirect to infobox" when client browser not fully support popup 
    	// override
    	$start_up_redirect_option = 2;
    }

    if ($start_up_redirect_option == 1) {
	// 20080708 - Save to session variable and add protocol checking
	$sess_desturl = $start_up_redirect_url;
	$_SESSION['sess_desturl'] = $start_up_redirect_url;
    }else if ($start_up_redirect_option == 2){
		$urlhead=fs_urlhead("infobox");
		$infobox_url=$urlhead.'info.php';
		$sess_desturl=$infobox_url;
		$_SESSION['sess_desturl']=$infobox_url;
	}

    $value = $settingobj->getKey("show_infobox", "gateway");

    // release the COM object
    $settingobj = null;
}

$access_directly = 0;
$redirect_pic_fname_html = "redirectpage_pic_name_html";		
$redirect_pic_fname = "redirectpage_pic_name";		
$redirect_html = get_html($redirect_pic_fname_html);
$redirect_pic = get_pic($redirect_pic_fname);
$input_pic = '';
$input = '';
$start_up_redirect_option = 0;
$start_up_redirect_url = '';
$start_up_redirect_wait = 0;
$wait_time = 0;
$value = 0;

// 20080707 - Obtain information from redirect link
if (isset($_GET['loginPage'])) {
    $loginPage = $_GET['loginPage'];
}
if (isset($_GET['sslredir'])) {
    $sslredir = $_GET['sslredir'];
    $_SESSION['sess_desturl'] = $sslredir;
    $sess_desturl = $sslredir;
}

// 20080707 - Change not to use session variables
if (isset($loginPage)) {
    $input_pic .= "
    <table width=\"100%\" border=\"0\" cellpadding=\"20\" valign=\"top\">";
    //picture was chosen for redirect poge
    if ($redirect_pic != '>') {
	$input_pic .= "
	<tr>
	    <td align=\"center\">";
	$redirect_pic = './loginpage_pic/'.$redirect_pic;
	//url was specified
	if ($redirect_html != '>') {
		$input_pic .= "
		<a href=\"".$redirect_html."\">";
	}
	$input_pic .= "
		<img src=\"".$redirect_pic."\" alt=\"".get_var('redirect_pic_alt')."\">
	    </td>
	</tr>";
    }
    $input = $input_pic;
    $input .= "
	<tr>
	    <td>";

    // 20080707 - Change not to use session variables
    if ($loginPage == true) {
	// access http://10.20.7.1:5788 directly
	$access_directly = 1;
	GetRedirectCfg();
	if ($start_up_redirect_option == 0) {
	    $input .= "
	    <span class=\"redirectspan\">".get_var('redirect_surf')."</span><br>
	    <span class=\"redirectaddr\">".get_var('redirect_addr')."</span>";
	} else {
	    $input .= "
	    <span class=\"redirectspan\">".get_var('redirect_wait')."</span><br>
	    <a href='".$_SESSION['sess_desturl']."'><span class=\"redirectaddr\">".get_var('redirect_msg')."</span></a>";
	}
        $input .= "
	    </td>
	</tr>
    </table>";
	// 20080707 - Change not to use session variables
        unset($loginPage);
        unset($sslredir);
    } else {
	GetRedirectCfg();
        $input .= "
		<span class=\"redirectspan\">".get_var('redirect_wait')."</span><br>
		<a href='".$_SESSION['sess_desturl']."'><span class=\"redirectaddr\">".get_var('redirect_msg')."</span></a>
	    </td>
	</tr>
    </table>";
    }
} else {
    $input_pic = "
    <table width=\"100%\" border=\"0\" cellpadding=\"30\" valign=\"top\">";
    //picture was chosen for redirect poge
    if ($redirect_pic != '>') {
	$redirect_pic = './loginpage_pic/'.$redirect_pic;	
	$input_pic .= "
	<tr>
	    <td align=\"center\">";
	//url was specified 
	if ($redirect_html != '>') {
	    $input_pic .= "
		<a href=\"".$redirect_html."\">";
	}
	$input_pic .= "
		<img src=\"".$redirect_pic."\" alt=\"".get_var('redirect_pic_alt')."\">
	    </td>
	</tr>";
    }
    GetRedirectCfg();
    $input = $input_pic;
    $input .= "
	<tr>
	    <td>
		<span class=\"redirectspan\">".get_var('redirect_wait')."</span><br>
		<a href='".$_SESSION['sess_desturl']."'><span class=\"redirectaddr\">".get_var('redirect_msg')."</span></a>
	    </td>
	</tr>
    </table>";
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('redirect.php FSCONFIG.Cfgmgr Object cannot be created!');
    $showinfo = $settingobj->getKey('show_infobox', 'gateway');
    $settingobj = null;
	//20080827	added redirect to info box option 
	if ($start_up_redirect_option == 2){//redirect to info box instead of pop-up
		$showinfo="off";
	}
    if (strtolower($showinfo) == "on" ) {
	// get the absolute path and infobox port
	$urlhead = fs_urlhead("infobox");
	//20080829	make infobox resizabe
	//acknowledge infobox
	$input .= "
    <script type='text/javascript'>
	var y = window.screen.availHeight - 25;
	var x = window.screen.availWidth - 10;
	var w = 400;
	var h = 200;
	y -= h;
	x -= w;
	if (test){
		popupWin = window.open('', 'firstspotInfoBox', 'toolbar=no,menubar=no,scrollbars=no,resizable=yes,top=' + y + ', left=' + x + ', height=' + h + ', width=' + w);
		if (popupWin) {
		    popupWin.location='".$urlhead."info.php';
		    popupWin.focus();
		};
	}
    </script>";
    }
}

// 20080708 - Use session variable for desturl
// 20080407 - Collect dynamic HTML content for layout
$smarty = new SmartyConnect;
$smarty->assign('L_REDIRECT_CHARSET', metaCharset());
$smarty->assign('L_REDIRECT_TITLE', get_var('redirect_title'));
$smarty->assign('REDIRECT_DESTURL', $sess_desturl);
$smarty->assign('J_REDIRECT_ACCESS_DIRECTLY', $access_directly);
$smarty->assign('J_REDIRECT_STARTUP_OPT', $start_up_redirect_option);
$smarty->assign('J_REDIRECT_WAIT_TIME', $wait_time);
$smarty->assign('L_REDIRECT_INPUT', $input);
$smarty->assign('J_COMMON', $j_common);

// 20080407 - Move layout content and include the file here
$smarty->display('redirect_body.tpl');


?>
