<?php
include_once "..\\cfgmgr\\sysfunc.php";
require_once 'smarty_connect.php'; // 20080402 - Link to Smarty connection file
//
//
// fs_timeleft
//
//
function fs_timeleft($username)
{
    // return values (timeleft field only):
    // >=0 if still have minutes left
    // =0 if no minutes left
    // -1 less than 1 minute
    // -2 unlimited

    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");

    // 20090204 - Get dummy input arguments
    $btLow = $settingobj->getKey('bt_low', 'bw_throttle');
    $btMedium = $settingobj->getKey('bt_medium', 'bw_throttle');
    $btHigh = $settingobj->getKey('bt_high', 'bw_throttle');

    // connect to database

    $dsn_file = $settingobj->getKey( "Datasource", "gateway");
    $dsn_source = fopen($dsn_file, "r") or die("Cannot open DSN source file!");  
    $dsn="";

    if(!feof($dsn_source)) 
        $line=fgets($dsn_source,512); 

    while(!feof($dsn_source)) {
        $line=fgets($dsn_source,512);
        if (trim($line)!="") $dsn=$dsn.$line;
    }

    $dsn=str_replace("\r\n",";",$dsn);

    // 20090326 - Suppress SQL error shown in client browser
    $er = error_reporting(0);
    $userDB = odbc_connect($dsn, "", "");
    error_reporting($er);

    // 20090204 - Obtain meaningful DB results by calling existing function
    // query for timeleft and login time for this client in firstspot user table
    if($userDB == 0) {
	$settingobj = NULL;
	return FALSE;
    } else {
		// 20090427 - Check authentication mode to determine which table should be used
        $firstspotusertable = fs_usr_table();
        $query="SELECT * FROM ".$firstspotusertable." WHERE NAME='".$username."';";
        $result=odbc_exec($userDB,$query); 

	$aUserDetail = array();
	if (odbc_fetch_row($result)) {
	    $aUserDetail = makeUserDetailFromODBCResult($result, $btLow, $btMedium, $btHigh);
	    $timeleft = $aUserDetail[3];
	    $islogin = $aUserDetail[4];
	    $expDate = $aUserDetail[11];
	    $expTime = $aUserDetail[12];
	    $bwQuotaDl = $aUserDetail[8];
	    $accBwDl = $aUserDetail[22];
	    $bwQuotaUl = $aUserDetail[23];
	    $accBwUl = $aUserDetail[25];
	    $bwQuotaSha = $aUserDetail[38];
	    $accBwSha = $aUserDetail[40];
	    $printQuota = $aUserDetail[26];
	    $logintime=odbc_result($result,"reserved2");
	}
    }

    //free COM object
    $settingobj=null;

    // end display timeleft coding

    // 20090204 - No return in time left section, save in return string
    // timeleft is an empty string only if unlimited timeleft condition is specified
    $retStr = '';
    if (isset($timeleft)) {
	if ($timeleft == "") {
	    $remains = -2;
	} else {
	    $timeleft = round($timeleft);

	    if ($timeleft == 0) {
		$remains = 0;
	    } else {
		if (isset($islogin) && $islogin != '' && isset($logintime)) {
		    // calculate escaped time (current time-login time)    

		    $diff = time() - $logintime;
		    $diff = $diff / 60;

		    // timeleft (allowed time limit-escaped time)

		    $timeleft = $timeleft - $diff;
		}

		if ($timeleft < 0) {
		    $timeleft = 0;
		}

		if (floor($timeleft) != 0) {
		    $remains = (int)floor($timeleft);
		} else {
		    $remains = -1;
		}
	    }
	}
	$retStr .= "$remains";
    }

    // 20090204 - Prepare expire date time
    if (isset($expDate) && isset($expTime)) {
	$retStr .= '|';
	if ($expDate != '' && $expTime != '') {
	    $retStr .= date('M j, Y g:i a', mktime_from_datetime($expDate, $expTime));
	}
    }

    // 20090204 - Prepare download data transfer information
    if (isset($bwQuotaDl) && isset($accBwDl)) {
	$retStr .= '|';
	if ($bwQuotaDl != '') {
	    $retStr .= $bwQuotaDl.'|'.$accBwDl;
	} else {
	    $retStr .= '|';
	}
    }

    // 20090204 - Prepare upload data transfer information
    if (isset($bwQuotaUl) && isset($accBwUl)) {
	$retStr .= '|';
	if ($bwQuotaUl != '') {
	    $retStr .= $bwQuotaUl.'|'.$accBwUl;
	} else {
	    $retStr .= '|';
	}
    }

    // 20090204 - Prepare total data transfer information
    if (isset($bwQuotaSha) && isset($accBwSha)) {
	$retStr .= '|';
	if ($bwQuotaSha != '') {
	    $retStr .= $bwQuotaSha.'|'.$accBwSha;
	} else {
	    $retStr .= '|';
	}
    }

    // 20090204 - Prepare print quota
    if (isset($printQuota)) {
	$retStr .= '|';
	if ($printQuota != '') {
	    $retStr .= $printQuota;
	}
    }

    return $retStr;
}//end fs_timeleft()

//
//
// fs_get_plan_info
//
//

function fs_get_plan_info($plan_name)
{
    $q="SELECT * FROM ".fs_plans_table()." WHERE pname='$plan_name'";
    $result=db_query($q);
    $field=array();

	// 20090402 - Add checking return valid result
	if ($result != FALSE && odbc_fetch_row($result)) {
		// 20071203 - Check and remove decimals for integer and numeric types
        for ($i = 1; $i <= odbc_num_fields($result); $i++) {
			if ((strtolower(odbc_field_type($result, $i)) == "numeric" || strtolower(odbc_field_type($result, $i)) == "integer") && odbc_result($result, $i) != null) {
				$field[strtoupper(odbc_field_name($result, $i))] = round(odbc_result($result, $i));
			} else {
				$field[strtoupper(odbc_field_name($result, $i))] = odbc_result($result, $i);
			}
		}
    }
    
    return $field;
}

//
//
// fs_usr_plan_update_query
//
//

function fs_usr_plan_update_query($plan_name, $username)
{
    $field = fs_get_plan_info($plan_name);
    $q = null;

    if (count($field) > 0) {
        $q = "UPDATE ".fs_usr_table()." SET ";
        foreach ($field as $key => $value)
            if (strlen($value)>0 && $key != "PNAME")
                $q .= "$key = '$value', ";
            else if ($key != "PNAME")
                $q .= "$key = NULL, ";

        $q = substr($q, 0, strlen($q) - 2);  //trim the ending comma
        $q .= " WHERE NAME = '$username'";
    }

    return $q;
}

//
//
// fs_cretae_user
//
//

function fs_create_user($username, $password1, $password2, $timeleft, $sess_patronsoft2,$security)
{
// return status (integer)
// 0 - no problem, id successfully created
// 1 - username cannot be empty
// 2 - duplicated user id found in user database
// 3 - password cannot be empty
// 4 - 2 passwords did not match
// 5 - restrict user to signup once and the user has signed up b4
// 6 - user can only signup in a period of time and the last signup 
//     time is still in the self signup period
// 7 - cannot get mac address
// 9 - security code did not match
// 10 - database not available
    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");

    // 20090324 - Moved from below
    $self_signup_filter = $settingobj->getKey( "self_signup_filter", "gateway");

    $status=99;
    $create_id="yes";

    if ($username =="") {
        $status =1;
        $create_id="no";

    // 20090324 - Block signing-up without IP/MAC if enforced sign-up restriction
    } elseif ($self_signup_filter == 0 && $sess_patronsoft2 == "") {
        $status =7;
        $create_id="no";

    } else {
        $q="SELECT count(*) as no FROM ".fs_usr_table()." where name='$username'";
        $result=db_query($q);

		// 20090402 - Add new return value for DB failure
		if ($result == FALSE) {
			$status = 10;
			$create_id = 'no';
		} else {
			$no = odbc_result($result, "no");

			$latest_signup_time = 0;

			// 20090324 - Check if sign-up restriction is on
			//if (not allow signup without) mac/ip OR (allow signup without mac/ip and the mac/ip is not null)
			if ($self_signup_filter == '0' && $sess_patronsoft2 != '') {
				$q = 'SELECT signuptime, name FROM '.fs_usr_table()." WHERE signupmac = '$sess_patronsoft2'";
				$rsut = db_query($q);

				// 20090402 - Add new return value for DB failure
				if ($rsut == FALSE) {
					$status = 10;
					$create_id = 'no';
				} else {
					while (odbc_fetch_row($rsut)) {
						$signup_name = odbc_result($rsut, "name");
						$self_signup_time = odbc_result($rsut, "signuptime");

						if ($self_signup_time > $latest_signup_time)
							$latest_signup_time = $self_signup_time;
					}
				}
			}
			$self_signup_period = $settingobj->getKey( "self_signup_period", "gateway");

			if (($no > 0) && ($username !="")) {
				$status =2;   //duplicated user id
				$create_id="no";
			}
			else if (($password1=="") && ($password2=="") && ($username !="") && ($create_id="yes")) {
				$status =3; //password not empty
				$create_id="no";
			}
			else if ((strcmp ($password1 , $password2) <> 0 ) && ($create_id="yes")) {
				$status =4; //passwords did not match
				$create_id="no";
			}
			else if ($security == false){
				$status = 9;
			  $create_id="no";
			}
			 else if ($self_signup_filter == 0) {    //ip/mac filter is on
				if ($self_signup_period == 0) {     //only allow user to signup once
					// 20090402 - Ensure no DB failure in the previous query
					if ($create_id == 'yes' && $latest_signup_time != 0) {  //user has signed up b4 accordding to its mac/ip
						$status = 5;
						$create_id="no";
					}
				} else if ($self_signup_period > 0) { //allow user to signup again after x mins
					// 20090402 - Ensure no DB failure in the previous query
					if ($create_id == 'yes' && $latest_signup_time != 0) {  //user has signed up b4 accordding to its mac/ip
						$currentTime = mktime();
						$diff = $currentTime - ($latest_signup_time + $self_signup_period * 60);
						if ($diff < 0) {            //latest signup time is still in the self signup period
							$status = 6;
							$create_id="no";
						}//end if
					}//end if
				}//end else if
			}//end else if
		}
    }

	if ($create_id == "yes") {
		$pwd_offload=$settingobj->getKey( "pwd_offload", "gateway");

		$version = $settingobj->getKey( "version", "version");    

		// 20090518 - Add Premium
		if (strtolower($pwd_offload) == "on" || strtolower($version) == "advanced" || strtolower($version) == 'premium') {
			$encrypt_path=$settingobj->getKey( "encrypt_path", "gateway");
			$cmd = "\"".$encrypt_path."\" ".$password1;
			//$pwd = $settingobj->runCommand($cmd);
			$sys = new sysfunc();
			$pwd = $sys->runCommand($cmd);
			$sys = null;
		} else {
			$fs_path = $settingobj->getFsPath();
			$cmd = "\"" . $fs_path . "dispatcher\\encrypt_pwd.exe\" ".$password1;
			//$pwd = $settingobj->runCommand($cmd);
			$sys = new sysfunc();
			$pwd = $sys->runCommand($cmd);
			$sys = null;
		}

		if ($timeleft == "")
			$timeleft="null";

		$now=mktime();
		$q="Insert into ".fs_usr_table()." (name, pwd, timeleft, signupmac, signuptime) values('$username', '$pwd', $timeleft, '$sess_patronsoft2', '$now')";
		$result_update=db_query($q);

		// 20090402 - Add new return value for DB failure
		if ($result_update == FALSE) {
			$status = 10;
		} else {
			$status = 0;
		}
	}
    //release COM object
    //$settingobj->Release();
    $settingobj=null;
    return $status;
}


//
//
// fs_is_password_correct
//
//

function fs_is_password_correct($username,$password)
{
	// 20090812 - Skip password check for Scratch mode, return TRUE for username exists
	// return TRUE for correct password
	// return FALSE otherwise

    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
    $pwd_offload=$settingobj->getKey( "pwd_offload", "gateway");
    $version = $settingobj->getKey( "version", "version");    
	$scratchLogin = $settingobj->getKey('scratch_login', 'gateway');

	if ($scratchLogin != 'on') {
		// 20090518 - Add Premium
		if (strtolower($pwd_offload) == "on" || strtolower($version) == "advanced" || strtolower($version) == 'premium') {
			$encrypt_path=$settingobj->getKey( "encrypt_path", "gateway");
			$cmd = "\"".$encrypt_path."\" ".$password;
			$sys = new sysfunc();
			$pwd = $sys->runCommand($cmd);
			$sys = null;
		} else {
			$fs_path = $settingobj->getFsPath();
			$cmd = "\"" . $fs_path . "dispatcher\\encrypt_pwd.exe\" " . $password;
			$sys = new sysfunc();
			$pwd = $sys->runCommand($cmd);
			$sys = null;
		}
	}

    //release COM object
    $settingobj=null;

	if ($scratchLogin == 'on') {
		$q = "SELECT count(*) as no FROM ".fs_usr_table()." where name='$username'";
	} else {
		$q = "SELECT count(*) as no FROM ".fs_usr_table()." where name='$username' and pwd='$pwd'";
	}
    $result=db_query($q);

	// 20090406 - Check if return valid result
	if ($result == FALSE) {
		return FALSE;
	}

    $no = odbc_result($result, "no");

    if ($no > 0) return TRUE;
    else return FALSE;
}


//
//
// fs_grab_paypal_history
//
//
function fs_grab_paypal_history($username)
{
    // return paypal transaction history
    $q="SELECT * from ".fs_ppal_table()." where USERNAME = '$username'";
    $result=db_query($q);
    return $result;
}


//
//
// db_query
//
//
function db_query($q, $r = false)   //return the result array of required query, $q
{
    // open dsn
    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
    if ($r == "true"){
	  		$dsn_file=$settingobj->getKey( "Datasource", "radius");
    }
    else
    		$dsn_file=$settingobj->getKey( "Datasource", "gateway");

    //release COM object
    //$settingobj->Release();
    $settingobj=null;

    $dsn_source=fopen($dsn_file, "r") or die("Cannot open DSN source file!");

    // prepare dsn string for ODBC connection
    $dsn="";

    if(!feof($dsn_source))
        $line=fgets($dsn_source,512);

    // read in each line
    while(!feof($dsn_source)) {
        $line=fgets($dsn_source,512);
        if(trim($line)!="")
            $dsn=$dsn.$line;
    }

    // replace newline with semicolon
    $dsn=str_replace("\r\n",";",$dsn);

    // 20090326 - Suppress SQL error shown in client browser
    // connect with ODBC
    $er = error_reporting(0);
    $userDB=odbc_connect($dsn,"","");
    error_reporting($er);

    // 20090326 - Improve error handling
    if ($userDB == 0) {
	$result = FALSE;
    } else {
	// connected
        $result = odbc_exec($userDB,$q);
    }

    //odbc_close($userDB);

    return $result;
}

function fs_is_anonymous_mode()
{
    // return true for either anonymous mode or SOHO Edition
    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
    $is_anon=$settingobj->getKey( "anonymous_login", "gateway");
    $vers=$settingobj->getKey( "version", "version");
    //release COM object
    //$settingobj->Release();
    $settingobj=null;

    if (!isset($vers))
        $vers="";
    if (!isset($is_anon))
        $is_anon="";

	// 20090518 - Remove Start
	if (($is_anon == "on") || ($is_anon == "ON"))
        return TRUE;
    else
        return FALSE;
}

function fs_is_ssl()
{
    //check if ssl is enabled 
    $settingobj = new com("fsconfig.cfgmgr") or die("common_functions.php fsconfig.cfgmgr object cannot be created!");
    $ssl_port = $settingobj->getKey( "ssl_auth_port", "gateway");
    //release com object
    //$settingobj->Release();
    $settingobj=null;

    if ($ssl_port=="443")
        return true;
    else
        return false;
}


function fs_local_ip_url()
{
    //get private nic's ip
    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
    $ip_address = $settingobj->getKey( "gateway_IP", "gateway");
    //release COM object
    //$settingobj->Release();
    $settingobj=null;

    if (fs_is_ssl())
        $head="https://";
    else
        $head="http://";
    return $head.$ip_address;

}
//20080724 added code for supporting PayPal Website Payments Pro Direct Payment
function fs_local_site_address()
{
	// 20090330 - Check version type for correct gateway domain
	// 20080617 - Check if put IP or domain into URL prefix
	//extract private ip and local's port and concat into string pointing main.php
	$settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
	$showDomainUrl = $settingobj->getKey("show_domain_URL", "gateway");
	$versionType = $settingobj->getKey('version', 'version');
	if (isset($showDomainUrl) && $showDomainUrl > 0) {
		// 20090518 - Remove Start
		if (substr_count(strtolower($versionType), 'standard') > 0) {
			$urlPref = 'firstspot.org';
		} else {
			$urlPref = $settingobj->getKey("gateway_domain", "gateway");
			if ($urlPref == '') {
				$urlPref = 'firstspot.org';
			}
		}
	} else {
		$urlPref = $settingobj->getKey("gateway_IP", "gateway");
	}
	$port_num = $settingobj->getKey("ssl_port", "gateway");
	$payment_method = $settingobj->getKey("payment_method", "creditcard");
	//release COM object
	$settingobj = null;
	if ($payment_method == "ppal") {
		$local_path = "http://".$urlPref.":".$port_num."/paypal_submit.php";
	} else if ($payment_method == "ppal_direct") {
		$local_path = "http://".$urlPref.":".$port_num."/direct_payment_submit.php";
	} else if ($payment_method == "worldpay") {
		$local_path = "http://".$urlPref.":".$port_num."/worldpay_submit.php";
	} else if ($payment_method == "authorizeNet") {
		$local_path = "http://".$urlPref.":".$port_num."/authorizenet_submit.php";
	} else if ($payment_method == "checkout") {
		$local_path = "http://".$urlPref.":".$port_num."/checkout_submit.php";
	} else if ($payment_method == "user_defined") {
		$local_path = "http://".$urlPref.":".$port_num."/udef_submit.php";
	}

	return $local_path;

}

function fs_form_to_load()
{
// extract which login form to load based on mode
// for anonymous mode (or soho edition) -> a_loginform parm in config.ini
// otherwise  -> login_form parm in config.ini

    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
    if ( fs_is_anonymous_mode())
        $form = $settingobj->getKey( "a_loginform", "gateway");
    else
        $form = $settingobj->getKey( "loginform", "gateway");
    //release COM object
    //$settingobj->Release();
    $settingobj=null;

    return $form; 

}

function fs_ppal_table()    //return PayPal table name from config.ini
{
    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
    $ppal_table=$settingobj->getKey( "Datasource_PayPal_Table", "gateway");
    //release COM object
    //$settingobj->Release();
    $settingobj=null;

    return $ppal_table;
}

function fs_plans_table()    //return FSPLANS table name from config.ini
{
    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
    $plans_table=$settingobj->getKey( "Datasource_Plans_Tablename", "gateway");
    //release COM object
    //$settingobj->Release();
    $settingobj=null;

    return $plans_table;
}

function fs_usr_table() //return FSUSR table name from config.ini
{
    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
    $use_radius = $settingobj->getKey( "use_radius", "radius");
    if( strtolower($use_radius)== "true" ){
        $dsn_file = $settingobj->getKey( "Datasource_Tablename", "radius");
    }else{
        $dsn_file=$settingobj->getKey( "Datasource_Tablename", "gateway");
    }
    //release COM object
    //$settingobj->Release();
    $settingobj=null;

    return $dsn_file;
}


function fs_exfield_table() //return extra user information table from config.ini
{
    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
    $ex_table=$settingobj->getKey( "Datasource_extra_field_table", "gateway");
    //$settingobj->Release();
    $settingobj=null;

    return $ex_table;
}


function datetime_from_mysql($datetime)
{
    if($datetime!="") {
        list($day,$mon,$date,$time,$year)    = explode(" ", $datetime);
        list($hr,$min,$sec)  = explode(":", $time);
        $newtime = mktime($hr, $min, $sec, toNumericMonth($mon), $date, $year);
        $d = date("m-d-Y", $newtime);
        $t = date("H:i", $newtime);
        return array ($d, $t);
    } else
        return array ("", "");
}

function datetime_from_mysql2($datetime)
{
    if($datetime!="") {
        list($day,$mon,$date,$time,$year)    = explode(" ", $datetime);
        list($hr,$min,$sec)  = explode(":", $time);
        $newtime = mktime($hr, $min, $sec, toNumericMonth($mon), $date, $year);
        $d = date("M j, Y", $newtime);
        $t = date("g:i a", $newtime);
        return array ($d, $t);
    } else
        return array ("", "");
}

function datetime_from_php($date, $time)
{
    if($date!="" && $time!="") {
        list($month,$date,$year) = explode("-", $date);
        list($hr, $min) = explode(":", $time);
        $newdate = mktime($hr, $min, 0, $month, $date, $year);
        $d = date("D M d H:i:s Y", $newdate);
        return $d;
    }
}

function mktime_from_datetime($date, $time)
{
    list($m, $d, $y) = explode("-", $date);
    list($h, $min) = explode(":", $time);
    return mktime((int)$h, (int)$min, 0, (int)$m, (int)$d, (int)$y);
}

function toNumericMonth($month)
{
    if(strcasecmp($month, "jan")==0)
        return 1;
    else if(strcasecmp($month, "feb")==0)
        return 2;
    else if(strcasecmp($month, "mar")==0)
        return 3;
    else if(strcasecmp($month, "apr")==0)
        return 4;
    else if(strcasecmp($month, "may")==0)
        return 5;
    else if(strcasecmp($month, "jun")==0)
        return 6;
    else if(strcasecmp($month, "jul")==0)
        return 7;
    else if(strcasecmp($month, "aug")==0)
        return 8;
    else if(strcasecmp($month, "sep")==0)
        return 9;
    else if(strcasecmp($month, "oct")==0)
        return 10;
    else if(strcasecmp($month, "nov")==0)
        return 11;
    else if(strcasecmp($month, "dec")==0)
        return 12;
    else 
        return 0;
}


function fs_is_shared_secret_in_anonymous_mode()
{
    // return true for either anonymous mode or SOHO Edition
    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
    $secret_enable=$settingobj->getKey( "secret_enable", "gateway");
    // free the COM object
    //$settingobj->Release();
    $settingobj=null;
    if (strtolower($secret_enable=='on') ) 
        return TRUE;
    else
        return FALSE;
}

function myIsInt ($x)
{
    return (is_numeric($x) ? intval($x) == $x : false);
} 

function isInSubnet($network, $snmask, $address)
{
    if (!is_array($network)) $network = explode(".", $network);
    if (!is_array($snmask))  $snmask  = explode(".", $snmask);
    if (!is_array($address)) $address = explode(".", $address);

    for ($i=0; $i<4; ++$i) {
        $a = $address[$i]*1;
        $m = $snmask[$i]*1;
        $n = $network[$i]*1;
        $m1 = $a & $m;
        $m2 = $n & $m;
        if (($a & $m)  != ($n & $m))
            return false;
    }
    return true;
}

// translate the the decimal MAC ($patronsoft2) into hexadecimal string format username
// use division method
function make_mac_name($number)
{
    $mac = "";
    for( $i = 0; $i < 6; $i++ ) {
        $char1 = strtoupper(dechex(bcmod($number, "16") ) );
        $number = bcdiv($number, "16");
        $char2 = strtoupper(dechex(bcmod($number, "16") ) );
        $number = bcdiv($number, "16");
        $mac .= $char2 . $char1;
        if( $i < 5 )
            $mac .= "-";
    }
    return $mac;
}

// This function is the resverse of make_mac_name()
// for testing use only
function mac_address_translate($macname)
{
    $mac = explode("-", $macname);
    $result = "";
    $i = 0;
    foreach($mac as $value) {
        // use BCMath functions because the number is too large
        $result = bcadd($result, bcmul( hexdec($value), bcpow(256, $i) ) );
        $i++;
    } 
    return $result;
}

function makeUserDetailFromODBCResult($result,$low,$medium,$high)
{
    /*
     *  Purpose: It analyse one row of result from odbc result 
     *  and return meaningful result about a user in an array
     */

	// 20090427 - Check if column exists before retrieving value
	if (odbc_field_num($result, 'name') == FALSE) {
		$name = '';
	} else {
		$name = odbc_result($result, "name");
	}

	if (odbc_field_num($result, 'MACasUsr') == FALSE) {
		$macuser = '';
	} else {
		$macuser = odbc_result($result, "MACasUsr");
	}

	if (odbc_field_num($result, 'pwd') == FALSE) {
		$pwd = '';
	} else {
		$pwd = odbc_result($result, "pwd");
	}

	if (odbc_field_num($result, 'timeleft') == FALSE) {
		$timeleft = '';
	} else {
		$timeleft = odbc_result($result, "timeleft");
	}

	if (odbc_field_num($result, 'btul') == FALSE) {
		$BTUL = '';
	} else {
		$BTUL = odbc_result($result, "btul");
	}

	if (odbc_field_num($result, 'btdl') == FALSE) {
		$BTDL = '';
	} else {
		$BTDL = odbc_result($result, "btdl");
	}

	if (odbc_field_num($result, 'bwrmethod') == FALSE) {
		$bwrmethod = '';
	} else {
		$bwrmethod = odbc_result($result, "bwrmethod");
	}

	if (odbc_field_num($result, 'bwrperiod') == FALSE) {
		$bwrperiod = '';
	} else {
		$bwrperiod = odbc_result($result, "bwrperiod");
	}
    if($bwrperiod>0)
        $bwrperiod = round($bwrperiod);

	if (odbc_field_num($result, 'bwrdate') == FALSE) {
		$bwrdate = '';
	} else {
		$bwrdate = odbc_result($result, "bwrdate");
	}
    if($bwrdate>0)
        $bwrdate = round($bwrdate);

	if (odbc_field_num($result, 'status') == FALSE) {
		$accStatus = 0;
	} else {
		$accStatus = round(odbc_result($result, "status"));
	}

	if (odbc_field_num($result, 'edate') == FALSE) {
		$edate = '';
	} else {
		$edate = odbc_result($result, "edate");
	}
	if (odbc_field_num($result, 'sdate') == FALSE) {
		$sdate = '';
	} else {
		$sdate = odbc_result($result, "sdate");
	}
    list($startDate, $startTime) = datetime_from_mysql($sdate);
    list($expiryDate, $expiryTime) = datetime_from_mysql($edate);

	if (odbc_field_num($result, 'eminutes') == FALSE) {
		$mins = '';
	} else {
		$mins = odbc_result($result, "eminutes");
	}
    $cmb_time="minutes";
    if($mins) {
        if (floor(($mins/60)/24)>0 && myIsInt(($mins/60)/24)){
            $mins=($mins/60)/24;
            $cmb_time="days";
        } else if(floor($mins/60)>0 && myIsInt($mins/60)){
            $mins=$mins/60;
            $cmb_time="hours";
        } else 
            $cmb_time="minutes";
        $mins=round($mins);
    }

	if (odbc_field_num($result, 'logins') == FALSE) {
		$logins = '';
	} else {
		$logins = odbc_result($result, "logins");
	}
    if($logins)
        $logins=round($logins);

    // 20080414 - Fix bug about returning 0 to else case from MYSQL
	if (odbc_field_num($result, 'startmod') == FALSE) {
		$smode = '';
	} else {
		$smode = odbc_result($result, "startmod");
	}
    if ($smode != "")
        $smode=round($smode);
    else
        $smode=1;

	if (odbc_field_num($result, 'bwcount') == FALSE) {
		$bwcount = '';
	} else {
		$bwcount = odbc_result($result,"bwcount");
	}

    if($bwcount=="") {
        $bwcount=-1;
        $bwquota="";
    }
    else if($bwcount==0) {
        $bwquota="";
    } else if($bwcount==1) {
        $bwquota="";
    } else if ($bwcount == 2) {
		if (odbc_field_num($result, 'bwquota') == FALSE) {
			$bwquota = 0;
		} else {
			$bwquota = round(odbc_result($result, "bwquota"));
		}
	} else {
        $bwcount=-1;
        $bwquota="";
    }

	if (odbc_field_num($result, 'bwcountUL') == FALSE) {
		$bwcountUL = '';
	} else {
		$bwcountUL = odbc_result($result, "bwcountUL");
	}

    if($bwcountUL=="") {
        $bwcountUL=-1;
        $bwquotaUL="";
    }
    else if($bwcountUL==0) {
        $bwquotaUL="";
    } else if($bwcountUL==1){
        $bwquotaUL="";
    } else if ($bwcountUL == 2) {
		if (odbc_field_num($result, 'bwquotaUL') == FALSE) {
			$bwquotaUL = 0;
		} else {
			$bwquotaUL = round(odbc_result($result, "bwquotaUL"));
		}
	} else {
        $bwcountUL=-1;
        $bwquotaUL="";
    }
    
    //bwcount global setting
    if ($bwcount==-1 || $bwcountUL==-1) {
    	$settingobj = new COM("FSCONFIG.Cfgmgr") or die("info.php FSCONFIG.Cfgmgr Object cannot be created!");
    	if ($bwcount==-1)
    		$bwcount_tmp=$settingobj->getKey( "bwcount_dl", "DataTransfer");
    	if ($bwcountUL==-1)
    		$bwcountUL_tmp=$settingobj->getKey( "bwcount_ul", "DataTransfer");
    	
    	if (isset($bwcount_tmp) && ($bwcount_tmp==1 || $bwcount_tmp==2))
    		$bwcount = -2;
    	
    	if (isset($bwcountUL_tmp) && ($bwcountUL_tmp==1 || $bwcountUL_tmp==2))
    		$bwcountUL = -2;
    		
    	if (isset($bwcount_tmp) && $bwcount_tmp==2)
    		$bwquota = $settingobj->getKey( "bwquota_dl", "DataTransfer");
    		
    	if (isset($bwcountUL_tmp) && $bwcountUL_tmp==2)
    		$bwquotaUL = $settingobj->getKey( "bwquota_ul", "DataTransfer");
		
	    $settingobj=null;
	}

    $usr_no = "";
    $usr_no_dl ="";

    if($BTUL==$low && $BTDL==$low) {
        $usr_bt_mode=1;
        $usr_no = round($low);
        $usr_no_dl = round($low);
    } else if($BTUL==$medium && $BTDL==$medium) {
        $usr_bt_mode=2;
        $usr_no = round($medium);
        $usr_no_dl = round($medium);
    } else if($BTUL==$high && $BTDL==$high) {
        $usr_bt_mode=3;
        $usr_no = round($high);
        $usr_no_dl = round($high);
    } else if ($BTUL=="" && $BTDL=="") {// use Global
        $usr_bt_mode=4;
        $usr_no = "";
        $usr_no_dl = "";
    } else if($BTUL==0 && $BTDL==0) {
        $usr_bt_mode=0;
    } else { // Fix it before 2.1 release,need to handle others - Alan
        $usr_bt_mode=5;
        $usr_no = round($BTUL);
        $usr_no_dl = round($BTDL);
    }

    // workaround for dbase datasource (as it always returns a number with decimal point)
    if($timeleft)
        $timeleft=round($timeleft);

	if (odbc_field_num($result, 'reserved1') == FALSE) {
		$reserved1 = '';
	} else {
		$reserved1 = odbc_result($result, "reserved1");
	}

	if (odbc_field_num($result, 'ACCUMBW') == FALSE) {
		$acc_bandwidth = 0;
	} else {
		$acc_bandwidth = odbc_result($result, "ACCUMBW");
		$acc_bandwidth = round($acc_bandwidth);
	}

	if (odbc_field_num($result, 'ACCUMBWUL') == FALSE) {
		$accumbwUL = 0;
	} else {
		$accumbwUL = odbc_result($result,"ACCUMBWUL");
		$accumbwUL = round($accumbwUL);
	}
    
	if (odbc_field_num($result, 'pagenum') == FALSE) {
		$printQuota = '';
	} else {
		$printQuota = odbc_result($result, 'pagenum');
		if($printQuota)
			$printQuota = round(odbc_result($result, 'pagenum'));
	}

	if (odbc_field_num($result, 'acl') == FALSE) {
		$acl = '';
	} else {
		$acl = odbc_result($result, 'acl');
	}

	if (odbc_field_num($result, 'reqsignup') == FALSE) {
		$reqsignup = '';
	} else {
		$reqsignup = odbc_result($result, 'reqsignup');
	}
    
    // get recurring data
	if (odbc_field_num($result, 'roption') == FALSE) {
		$recur_option = '';
	} else {
		$recur_option = odbc_result($result, "roption");
	}

	if (odbc_field_num($result, 'rsdate') == FALSE) {
		$recur_sdate = '';
	} else {
		$recur_sdate = odbc_result($result, "rsdate");
	}

	if (odbc_field_num($result, 'redate') == FALSE) {
		$recur_edate = '';
	} else {
		$recur_edate = odbc_result($result, "redate");
	}

	if (odbc_field_num($result, 'weeksch') == FALSE) {
		$week_sch = '';
	} else {
		$week_sch = odbc_result($result, "weeksch");
	}

    // get reset option
	if (odbc_field_num($result, 'resetopt') == FALSE) {
		$reset_option = 0;
	} else {
		$reset_option = odbc_result($result, "resetopt");
		if ($reset_option != null)
			$reset_option = round($reset_option);
		else
			$reset_option = 0;
	}
		
    // get auto del
	if (odbc_field_num($result, 'auto_del') == FALSE) {
		$autodel = 0;
	} else {
		$autodel = odbc_result($result, 'auto_del');
		if ( strlen($autodel) > 0 && $autodel==1 )
			$autodel = 1;
		else
			$autodel = 0;
	}
        
   	// get macmap
	if (odbc_field_num($result, 'macmap') == FALSE) {
		$mac_map = 0;
	} else {
		$mac_map = odbc_result($result, "macmap");
		if ($mac_map != null)
			$mac_map = round($mac_map);
		else
			$mac_map = 0;
	}
        
    // get ipmap
	if (odbc_field_num($result, 'ipmap') == FALSE) {
		$ip_map = 0;
	} else {
		$ip_map = odbc_result($result, "ipmap");
		if ($ip_map != null)
			$ip_map = round($ip_map);
		else
			$ip_map = 0;
	}
        
    //get lastrbw
	if (odbc_field_num($result, 'lastrbw') == FALSE) {
		$lastrbw = '';
	} else {
		$lastrbw = odbc_result($result, "lastrbw");
	}
	
	if (odbc_field_num($result, 'bwcountSHA') == FALSE) {
		$bwcountSHA = '';
	} else {
		$bwcountSHA = odbc_result($result, "bwcountSHA");
	}

    if($bwcountSHA=="") {
        $bwcountSHA=0;
        $bwquotaSHA="";
    }
    else if($bwcountSHA==0) {
        $bwquotaSHA="";
    } else if($bwcountSHA==1){
        $bwquotaSHA="";
    } else if ($bwcountSHA == 2) {
		if (odbc_field_num($result, 'bwquotaSHA') == FALSE) {
			$bwquotaSHA = 0;
		} else {
			$bwquotaSHA = round(odbc_result($result, "bwquotaSHA"));
		}
	} else {
        $bwcountUL=0;
        $bwquotaUL="";
    }
		
	if (odbc_field_num($result, 'ACCUMBWSHA') == FALSE) {
		$accumbwSHA = 0;
	} else {
		$accumbwSHA = odbc_result($result, "ACCUMBWSHA");
		$accumbwSHA = round($accumbwSHA);
	}

        
    $valueArray = array("$name","$macuser","$pwd","$timeleft","$reserved1","$usr_bt_mode","$usr_no","$usr_no_dl","$bwquota","$bwcount","$accStatus","$expiryDate","$expiryTime","$startDate","$startTime","$logins","$mins","$cmb_time","$smode","$bwrmethod","$bwrperiod","$bwrdate","$acc_bandwidth","$bwquotaUL","$bwcountUL","$accumbwUL","$printQuota","$acl","$reqsignup","$recur_option","$recur_sdate","$recur_edate","$week_sch", "$reset_option", "$autodel", "$mac_map", "$ip_map", "$lastrbw", "$bwquotaSHA", "$bwcountSHA", "$accumbwSHA");
    $valueString = join(",",$valueArray);
    return $valueArray;
}

function fs_printlog_table() //return FSUSR table name from config.ini
{
    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
    $dsn_file=$settingobj->getKey( "Datasource_Printlog", "gateway");
    //release COM object
    //$settingobj->Release();
    $settingobj=null;

    return $dsn_file;
}

function print_support_link($location)
{
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('common_functions.php FSCONFIG.Cfgmgr Object cannot be created!');

    $print_support = $settingobj->getKey( 'PrintSupport', 'PrinterOn');
    $printerOn_siteURL = $settingobj->getKey( 'SiteURL', 'PrinterOn');
    $show_URL_login = $settingobj->getKey( 'show_URL_login', 'PrinterOn');
    $show_URL_infobox = $settingobj->getKey( 'show_URL_infobox', 'PrinterOn');

    //release COM object
    //$settingobj->Release();
    $settingobj=null;

    // 20080403 - Return value instead of echo
    if ($print_support == '1' && $show_URL_infobox == '1' && $location == 'infobox') {
        return '<a href="'.$printerOn_siteURL.'" class="infoboxlink" target="_blank">'.get_var('print_support').'</a>';
    } else if ($print_support == '1' && $show_URL_login == '1' && $location == 'login') {
        return '<a href="'.$printerOn_siteURL.'" class="freelink">'.get_var('print_support').'</a>';
    }
}

function shopping_cart_link($endParm="")
{
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('common_functions.php FSCONFIG.Cfgmgr Object cannot be created!');

    $show_cart = $settingobj->getKey( 'show_cart', 'misc');

    //release COM object
    //$settingobj->Release();
    $settingobj=null;
    
    // get the absolute path 
	$urlhead=fs_urlhead();

    // 20080403 - Return value instead of echo
    if ($show_cart == 'yes') {
        return '<a href="'.$urlhead.'cart.php'.$endParm.'" class="infoboxlink" target="_blank">'.get_var('info_cart_btn')."</a>\n";
    }
}

function change_password_link()
{
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('common_functions.php FSCONFIG.Cfgmgr Object cannot be created!');

    $enable_chgpwd = $settingobj->getKey( 'enable_chgpwd', 'misc');

    //release COM object
    //$settingobj->Release();
    $settingobj=null;
    
    // get the absolute path 
	$urlhead=fs_urlhead();
    
    // 20080403 - Return value instead of echo
    if ($enable_chgpwd) {
        return '<a href="'.$urlhead.'chgpwd_form.php" class="infoboxlink" target="_blank">'.get_var('info_chgpwd_btn')."</a>\n";
    }
}

function exportDB($exportImportFile, $table, $Datasource)
{
    $export_file = $exportImportFile;
    
    $use_radius = false;
    
    // only url to check use_radius
    if (isset($table) && $table == "url") {
	    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
		  $use_radius=$settingobj->getKey( "use_radius", "radius");
	    //release COM object
	    //$settingobj->Release();
	    $settingobj=null;
	  }
    
    //main() 
    // get all the row names from database
    $q="SELECT * FROM ".$Datasource;
    $res=db_query($q, $use_radius);
    $row = array();
    $result = array();
    $result = odbc_fetch_row($res);
    $nf = odbc_num_fields($res); 
    for($count=1; $count < $nf+1; $count++) {
        $field_name = odbc_field_name($res, $count);
        $field_value = odbc_result($res, $field_name);
        $row[$field_name] = $field_value;
    }
    $col_string="";
    $iNumCol=0; //number of columns minus reserved fields
    foreach ($row as $key => $value) {
        if (!stristr($key,"reserved") || ($table != "user")) {
            $indi_col_name[$iNumCol]=$key;   //array containing name of each field (except reserved fields)
            $iNumCol= $iNumCol+1;
            $col_string.=$key.",";  
        }
    }
    $col_string=substr($col_string, 0, strlen($col_string)-1);  
    // = "name, pwd, ...., .... " (without names of reserved fields)

    // test each field to see whether it's numeric or varchar types
    // so that to include a pair of quotation marks for varchar types when output to the csv file
    // the testing method is to insert a character into each column to see if successful
    // for a integer/numeric column, this will return nothing to the subsequent select query
    $er=error_reporting(0); //supress all error during insert failure, store the old level of error_reporting
    $special_dummy_name="zzfirstspotexportzz";

    if (isset($table) && $table == "user") {
        for ($i=0; $i < $iNumCol ; $i++) {
            //always delete this dummy row before testing
            $q="DELETE FROM ".$Datasource." where name = '$special_dummy_name'";
            $res=db_query($q);

            if (strtolower($indi_col_name[$i]) != "name") { // only test type if field != 'name'
                //insert a varchar into the current column
                $q="INSERT INTO ".$Datasource." (name, ".$indi_col_name[$i]." ) values ('$special_dummy_name','a')";
                $res=db_query($q);

                //select it back to see if the previous is successful
                $q="SELECT * FROM ".$Datasource." WHERE name = '$special_dummy_name'";
                $res=db_query($q);
                if (odbc_fetch_row($res)) { //if successful
                    $indi_col_type[$i] = "v"; // which is a varchar type
                } else
                    $indi_col_type[$i]= "n"; // which is a numeric type
            } else
                $indi_col_type[$i]="v"; // the field 'name' is always varchar type

            //always delete this dummy row after testing
            $q="DELETE FROM ".$Datasource." where name = '$special_dummy_name'";
            $res=db_query($q);
        }

        error_reporting($er); //resume the default error reporting mode

        //select all rows without the reserved files, ready to write into the csv file
        $q="SELECT $col_string FROM ".$Datasource;
    } else if (isset($table) && $table == "plan") {
        for ($i=0; $i < $iNumCol ; $i++) {
            //always delete this dummy row before testing
            $q="DELETE FROM ".$Datasource." where pname = '$special_dummy_name'";
            $res=db_query($q);

            if (strtolower($indi_col_name[$i]) != "pname") { // only test type if field != 'pname'
                //insert a varchar into the current column
                $q="INSERT INTO ".$Datasource." (pname, ".$indi_col_name[$i]." ) values ('$special_dummy_name','a')";
                $res=db_query($q);

                //select it back to see if the previous is successful
                $q="SELECT * FROM ".$Datasource." WHERE pname = '$special_dummy_name'";
                $res=db_query($q);
                if (odbc_fetch_row($res)) { //if successful
                    $indi_col_type[$i] = "v"; // which is a varchar type
                } else
                    $indi_col_type[$i]= "n"; // which is a numeric type
            } else
                $indi_col_type[$i]="v"; // the field 'pname' is always varchar type

            //always delete this dummy row after testing
            $q="DELETE FROM ".$Datasource." where pname = '$special_dummy_name'";
            $res=db_query($q);

        }

        error_reporting($er); //resume the default error reporting mode

        //select all rows without the reserved files, ready to write into the csv file
        $q="SELECT $col_string FROM ".$Datasource; 
    } else if (isset($table) && $table == "cc") {
        for ($i=0; $i < $iNumCol ; $i++) {
            //always delete this dummy row before testing
            $q="DELETE FROM ".$Datasource." where invoice = 0";

            $res=db_query($q);

            if (strtolower($indi_col_name[$i]) != "invoice")  // only test type if field != 'invoice'
            { //insert a varchar into the current column
                $q="INSERT INTO ".$Datasource." (invoice, ".$indi_col_name[$i]." ) values (0,'a')";
                $res=db_query($q);

                //select it back to see if the previous is successful
                $q="SELECT * FROM ".$Datasource." WHERE invoice = 0";
                $res=db_query($q);
                if (odbc_fetch_row($res)) { //if successful
                    $indi_col_type[$i] = "v"; // which is a varchar type
                } else
                    $indi_col_type[$i]= "n"; // which is a numeric type
            } else
                $indi_col_type[$i]="n"; // the field 'invoice' is always numeric type

            //always delete this dummy row after testing
            $q="DELETE FROM ".$Datasource." where invoice = 0";
            $res=db_query($q);

            //echo $i."=".$indi_col_name[$i]."=".$indi_col_type[$i];
        }

        error_reporting($er); //resume the default error reporting mode

        //select all rows without the reserved files, ready to write into the csv file
        $q="SELECT $col_string FROM ".$Datasource; 
    } else if (isset($table) && $table == "group") {
        for ($i=0; $i < $iNumCol ; $i++) {
            //always delete this dummy row before testing
            $q="DELETE FROM ".$Datasource." where groupname = '$special_dummy_name'";
            $res=db_query($q);

            if (strtolower($indi_col_name[$i]) != "groupname") { // only test type if field != 'groupname'
                //insert a varchar into the current column
                $q="INSERT INTO ".$Datasource." (groupname, ".$indi_col_name[$i]." ) values ('$special_dummy_name','a')";
                $res=db_query($q);

                //select it back to see if the previous is successful
                $q="SELECT * FROM ".$Datasource." WHERE groupname = '$special_dummy_name'";
                $res=db_query($q);
                if (odbc_fetch_row($res)) { //if successful
                    $indi_col_type[$i] = "v"; // which is a varchar type
                } else
                    $indi_col_type[$i]= "n"; // which is a numeric type
            } else
                $indi_col_type[$i]="v"; // the field 'groupname' is always varchar type

            //always delete this dummy row after testing
            $q="DELETE FROM ".$Datasource." where groupname = '$special_dummy_name'";
            $res=db_query($q);

        }

        error_reporting($er); //resume the default error reporting mode

        //select all rows without the reserved files, ready to write into the csv file
        $q="SELECT $col_string FROM ".$Datasource; 
    } //end if export group

    $res=db_query($q,$use_radius);
    $file_content=$col_string."\r\n";
    $num_row=0; 
    // 20080128 - Fetch row before getting results
    while (odbc_fetch_row($res)) {
        $num_row++;
        for ($i=1; $i < $iNumCol +1; $i++) { //concat all values
            $a=odbc_result($res,$i);
            if ($a == "")
                $a="NULL";
            if ($indi_col_type[$i-1] == "v" && ($a != "NULL")) //add a pair quotation marks for varchar type
                $file_content.="'".$a."',"; 
            else
                $file_content.= $a.",";
        }
        $file_content=substr($file_content,0,strlen($file_content)-1)."\r\n";
    }

    //write it as a csv file
    if (is_file("..\\".$export_file) == FALSE)
        touch ("..\\".$export_file);
    $fileHandler = fopen ("..\\".$export_file, "w");
    fwrite ($fileHandler, $file_content);
    fclose ($fileHandler);
    // report how many lines exported
    $msg = "<b><font color=\"blue\">Export done!</font></b><p>";
    $msg.= "Number of recorded exported: ".$num_row."<br>";
    $msg.= "The file <b>$export_file</b> is now under the FirstSpot directory of the FirstSpot server machine.<p>";
    $msg.= "Please keep it in a safe place for future version upgrade or reinstallation.<br>";
    $msg.= "Please be reminded that all files left under the FirstSpot directory will be removed during uninstallation.<p>";
    return $msg;
    // end main
}

function importDB($exportImportFile, $table, $Datasource)
{
    //global variables
    $source_file=$exportImportFile;

    if (!file_exists("..\\".$source_file))
        $msg = "<b>Warning:</b><p>The file <b>".$source_file."</b> is not found. Please make sure it is put under the <b>FirstSpot directory</b> on the FirstSpot server machine.<br>Import aborted.<p>";
    else { //carry on
        // get all the row names from database
        $q="SELECT * FROM ".$Datasource;
        $res = db_query($q);
        $row = array();
        $result = array();
        $result = $res;
        $nf = odbc_num_fields($res); 
        //echo $nf;
        for($count=1; $count < $nf+1; $count++) {
            $field_name = odbc_field_name($res, $count);
            $field_value = odbc_result($res, $field_name);
            $row[$field_name] = $field_value;
        }

        $col_string="";
        $iNumCol=0; //number of columns minus reserved fields
        foreach ($row as $key => $value) {
            if (!stristr($key,"reserved") || ($table != "user")) {
                $indi_col_name[$iNumCol]=$key;   //array containing name of each field (except reserved fields)
                $iNumCol= $iNumCol+1;
                $col_string.=$key.",";  
            }
        }
        $col_string=substr($col_string, 0, strlen($col_string)-1);  
        // = "name, pwd, ...., .... " (without names of reserved fields)

        $er=error_reporting(0); //supress all error during insert failure, store the old level of error_reporting

        //open the csv file, 
        $handle = fopen("..\\".$source_file, "r");
        $row=1;  
        $failed_row_name=""; //storing duplicated rows found in csv file
        $failed_row_count=0;
        while ($csv_data = fgetcsv($handle, 1000, ",")) {
            if ($row==1) { //get the first row, to see what fields are there
                $num_field=count($csv_data); //number of fields in each row
                $insert_string_1=""; //prepare first part of insert string
                for ($c=0; $c < $num_field; $c++) { //for each field in csv file
                    if (isset($table) && $table == "user") {
                        if (trim(strtolower($csv_data[$c]))=="name") //search which column is the name col
                            $name_col=$c;
                    } else if (isset($table) && $table == "plan") {
                        if (trim(strtolower($csv_data[$c]))=="pname") //search which column is the pname col
                            $name_col=$c;
                    } else if (isset($table) && $table == "cc") {
                        if (trim(strtolower($csv_data[$c]))=="invoice") //search which column is the invoice col
                            $name_col=$c;
                    } else if (isset($table) && $table == "group") {
                        if (trim(strtolower($csv_data[$c]))=="groupname") {//search which column is the primary key (name) col
                            $name_col=$c;
                        }
						if (trim(strtolower($csv_data[$c]))=="secret") {
							$secret_col = $c;
						}
                    }
                    $column_exist[$c]=FALSE;  
                    $convert_unit[$c]=FALSE; //change days to eminutes from 3.0.4
                    for ($i=0; $i < $iNumCol; $i++) { //check if column exist in table
                        if ( strtolower($csv_data[$c]) == strtolower($indi_col_name[$i])) {
                            $column_exist[$c] = TRUE;
                            $convert_unit[$c]=FALSE;
                            $insert_string_1.= $csv_data[$c].",";
                        } else if(strcasecmp(strtolower($csv_data[$c]), "days")==0 && strcasecmp(strtolower($indi_col_name[$i]), "eminutes")==0){
                            $column_exist[$c] = TRUE;
                            $convert_unit[$c]=TRUE;
                            $insert_string_1.= "eminutes,";
                        }
                    }
                }
                $insert_string_1=substr($insert_string_1, 0, strlen($insert_string_1)-1);  //trim the ending comma
            } else {
                //read in the data lines
                $insert_string_2="";
                for ($c=0; $c < $num_field; $c++) {
                    if ($column_exist[$c]){
                        /*Following code is written to maintain the compatibility of DB when importing DB from versions before 3.0.4 to version 3.0.4 or later*/
                        if($convert_unit[$c]==TRUE && strcasecmp(strtolower($csv_data[$c]),"null")!=0){
                            if(!is_int($csv_data[$c])) {
                                $num = explode("'", $csv_data[$c]); //strip single quotes
                                $num2="";
                                $i=0;
                                while ($i<count($num)) { //concat array into integer
                                    $num2.=$num[$i];
                                    $i++;
                                }
                                $num3 = ((int)$num2)*24*60; //from days to minutes
                            } else{
                                $num3=((int)$csv_data[$c])*24*60;
                            }                    
                            $insert_string_2.= "'".$num3."'".",";
                        } else {
                            //the following code fixes a bug that was found in v3.1.1 which pay_date field is 
                            //populated with a date that contains a comma and thus causes the table to place 
                            //data into the incorrect table fields.

                            if(!is_int($csv_data[$c]) && strcasecmp(strtolower($csv_data[$c]),"null")!=0) {
                                if((substr($csv_data[$c], 0, 1)=="'" &&
                                substr($csv_data[$c], strlen($csv_data[$c])-1, strlen($csv_data[$c]))!="'") ||
                                (substr($csv_data[$c], 0, 1)!="'" &&
                                substr($csv_data[$c], strlen($csv_data[$c])-1, strlen($csv_data[$c]))=="'"))
                                {
                                    $csv_data[$c]= $csv_data[$c].",".$csv_data[$c+1];
                                    //echo $csv_data[$c] . "<BR>";
                                    $num_field++;
                                    for ($x=$c+1; $x < $num_field; $x++) {
                                        $csv_data[$x] = $csv_data[$x+1];
                                    }
                                }    
                            }
                            $insert_string_2.= $csv_data[$c].",";
                        }
                        /********************************************************************************************************************/
                    }
                }

                //check for duplicated records in a generic way
                if (isset($table) && $table == "user")
                    $q="SELECT * FROM ".$Datasource." WHERE NAME=".$csv_data[$name_col]."";
                else if (isset($table) && $table == "plan")
                    $q="SELECT * FROM ".$Datasource." WHERE PNAME=".$csv_data[$name_col]."";
                else if (isset($table) && $table == "cc")
                    $q="SELECT * FROM ".$Datasource." WHERE INVOICE=".$csv_data[$name_col]."";
                else if (isset($table) && $table == "group") {
                    $q="SELECT * FROM ".$Datasource." WHERE groupname =".$csv_data[$name_col]." OR secret =".$csv_data[$secret_col]."";
                }

                $res1=db_query($q);

                if (!odbc_fetch_row($res1)) {
                    //which means there's NO duplicated record - safe to insert record
                    $insert_string_2=substr($insert_string_2, 0, strlen($insert_string_2)-1);  //trim the ending comma
                    $q="INSERT INTO ".$Datasource." ( ".$insert_string_1." ) VALUES ( ".$insert_string_2." )";
                    $res=db_query($q);
                } else {
                    //duplicate record
                    $failed_row_name.=$csv_data[$name_col]."<br>";
                    $failed_row_count++;
                }
            }

            $row++;
        }
        $row=$row-2;
        $row_ok=$row-$failed_row_count;
        error_reporting($er); //resume the default error reporting mode
        fclose($handle); // close the csv file handle

        //report total number of records in csv, how many ok, how many fails
        $msg = "<b><font color=\"blue\">Import done!</font></b><br>";
        $msg.= "Number of records in the csv files: ".$row."<br>";
        $msg.= "Number of records successfully imported to FirstSpot ".$Datasource." database: ".$row_ok."<br>";
        //$msg.= "Number of records skipped due to duplicated username found: ".$failed_row_count."<p>";
		$msg.= "Number of records skipped due to duplicated username or same secert code found : ".$failed_row_count."<p>";
        if ($failed_row_name != "")
            //$msg .= "<b>Records with these usernames are skipped:</b><br>".$failed_row_name;
			$msg .= "<b>Records with these usernames are skipped from import csv :</b><br>".$failed_row_name;
    } // endif datafile is found
    // end main
    return $msg;
}

function isValidIP($ipString)
{
    //IP validation
    if (preg_match("/^\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b$/", $ipString)) { 
        return true;
    } else {
        return false;
    }
}

// translate the the decimal ip ($patronsoft1) into hexadecimal string format username
// use division method
function make_ip_name($number)
{
    $ip = "";
    $IP_str=long2ip($number);  
    $tok = explode('.', $IP_str);
    $ip=$tok[3].'.'.$tok[2].'.'.$tok[1].'.'.$tok[0];

    return $ip;
}

//generate a random number
function gen_random_no($count)
{
	srand(time());
	$random_no = (rand()%$count);
	return $random_no;
}

//get the picture from the specified file
function get_pic($fname)
{
	$settingobj = new COM('FSCONFIG.Cfgmgr') or die('fs_login.php FSCONFIG.Cfgmgr Object cannot be created!');
	$value=$settingobj->getKey( $fname, 'gateway');
	if($value==""){
		//the way to distinguish if no picture was chosen
		$value='>';
	}
	return $value;
}


function get_html($html_file)
{	
	$settingobj = new COM('FSCONFIG.Cfgmgr') or die('fs_login.php FSCONFIG.Cfgmgr Object cannot be created!');

	$login_page_html=$settingobj->getKey( $html_file, 'gateway');
	if($login_page_html==""){
		//the way to distinguish if no url was established
		$login_page_html='>';
	}
	return $login_page_html;
}

function fs_is_checkInfoClosed()
{
    $settingobj = new com("fsconfig.cfgmgr") or die("common_functions.php fsconfig.cfgmgr object cannot be created!");
    $check_infobox_closed = $settingobj->getKey( "check_infobox_closed", "gateway");
     $show_infobox = $settingobj->getKey( "show_infobox", "gateway");
    $settingobj=null;

    if (isset($check_infobox_closed) && strtolower($check_infobox_closed) == "on" && 
    	isset($show_infobox) && strtolower($show_infobox) == "on")
        return true;
    else
        return false;
}

// get absolute path (*infobox will combine with info port)
function fs_urlhead($str="")
{
	
    // 20080530 - Add extracting show_domain_URL flag
    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
    $infobox_port = $settingobj->getKey("infobox_port", "gateway");
    $_relative_path = $settingobj->getKey("_relative_path", "gateway");
    $showDomainUrl = $settingobj->getKey("show_domain_URL", "gateway");
    $settingobj=null;
	
    // 20080530 - Check if put IP or domain into URL prefix
    if (isset($showDomainUrl) && $showDomainUrl > 0) {
	$urlhead = fs_local_domain_url();
    } else {
	$urlhead = fs_local_ip_url();
    }
    switch (strtolower($str)) {
    case "infobox":
	$urlhead .= ":".$infobox_port."/";
	break;
    default :
	$urlhead .= "/";
    }
	
	//override urlhead if using relative path
	if (!fs_is_checkInfoClosed() && isset($_relative_path) && strtolower($_relative_path) == "true")
		$urlhead="";
	
    return $urlhead;
}

// 20080401 - Output include content of the inputted file
function GetIncludeContent($filename)
{
    if (is_file($filename)) {
	ob_start();
	include $filename;
	$content = ob_get_contents();
	ob_end_clean();

	return $content;
    } else {
	return '';
    }
}

// 20080401 - Output include_once content of the inputted file
function GetIncludeOnceContent($filename)
{
    if (is_file($filename)) {
	ob_start();
	include_once $filename;
	$content = ob_get_contents();
	ob_end_clean();

	return $content;
    } else {
	return '';
    }
}

// 20080410 - Replace old genTable function, use template calling method
function GenTable($metaStr, $inputStr, $scriptStr)
{
	require 'generate_common.php';
    $smarty = new SmartyConnect;
    $smarty->assign('L_GEN_TABLE_META', $metaStr);
    $smarty->assign('L_GEN_TABLE_SCRIPT', $scriptStr);
    $smarty->assign('L_GEN_TABLE_INPUT', $inputStr);
    $smarty->assign('J_COMMON', $j_common);
    $smarty->display('gen_table_body.tpl');

    exit;
}

// 20080530 - Return domain name URL prefix
function fs_local_domain_url()
{
	// 20090330 - Check version type for correct gateway domain
	$settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
	$versionType = $settingobj->getKey('version', 'version');

	// 20090518 - Remove Start
	if (substr_count(strtolower($versionType), 'standard') > 0) {
		$dn = 'firstspot.org';
	} else {
		$dn = $settingobj->getKey("gateway_domain", "gateway");
		if ($dn == '') {
			$dn = 'firstspot.org';
		}
	}
	$settingobj = null;

    if (fs_is_ssl()) {
        $head = "https://";
    } else {
	$head = "http://";
    }

    return $head.$dn;
}

// checking client's browser user agent, 0: desktop, 1: mobile
// * if not contain all of mobile token entry, the default result will be desktop
function checking_ua($http_user_agent)
{
	if (file_exists("..\\uaToken.csv")){
		$all_count=0;
		$row=0; 
		$num_field=0;
		// open the csv file, 
		$handle = fopen("..\\uaToken.csv", "r");
		// get csv data
		while ($csv_data = fgetcsv($handle, 100, ",")) {
	        if (strstr($csv_data[0], ';')){
		        // comment ignore it
	        }else{
    			if ($all_count==0) {
					$num_field=count($csv_data); // number of fields in each row
		        }
		        for ($c=0; $c < $num_field; $c++) {
			        $all_array[$all_count][$c]= strtolower($csv_data[$c]);
		        }
		        $all_count++;
	        }
	        $row++;
		}
		
		fclose($handle); // close the csv file handle
		
// 		print_r($all_array);
		$m_count =0;
		$d_count =0;
		if (isset($all_array)){
			for($d=0; $d<count($all_array); $d++){
				// auume csv file is well known format, [0] - token string , [1] - token type
				if ($all_array[$d][1] == "m"){// mobile
					$m_array[$m_count] =  $all_array[$d][0] ;
					$m_count++;
				}else if ($all_array[$d][1] == "d"){// desktop
					$d_array[$d_count] =  $all_array[$d][0] ;
					$d_count++;
				}
			}
		}
// 		print_r($m_array);
// 		print_r($d_array);

		// checking: (1) mobile token string (2) desktop token string  

		// uses the generated regex above to see if those keywords are contained in the user agent variable
		// mobile text
		if ($m_count>0){
			$m_regex = '('.implode($m_array, ')|(').')';
			if (eregi($m_regex, strtolower($http_user_agent))){
				return 1;
			}
		}
		// desktop text
		if ($d_count > 0){
			$d_regex = '('.implode($d_array, ')|(').')';
			if (eregi($d_regex, strtolower($http_user_agent))){
				return 0;
			}
		}
	}
	
	return 0;
}

function calculateDuration($logintime){
	// calculate elapsed time (in seconds!)
	$diff = time()-$logintime;
	
	$timeDiff = $diff; // durication in sec format
	
	$daysDiff = floor($diff/60/60/24);
	$diff -= $daysDiff*60*60*24;
	$hrsDiff = floor($diff/60/60);
	$diff -= $hrsDiff*60*60;
	$minsDiff = floor($diff/60);
	$diff -= $minsDiff*60;
	$secsDiff = $diff;
	
	// calculate escaped time (current time-login time)
	$duration = $daysDiff.'d '.$hrsDiff.'h '.$minsDiff.'m '.$secsDiff.'s';
	
	// 20090611 - Output value in second also
	return "$timeDiff|$duration";
}

// arrUserDataField Handle: expiryDate, recur_option, recur_stime, recur_etime, logintime, session_limit, max_time
// return: -1 = none, >0 (in second)
function cal_timeleft_reminder($arrUserDataField){
    
	foreach( $arrUserDataField as $key => $val ){
		switch ($key) {
			case 'expiryDate':
			$expiryDate = $val;
			break;
			case 'recur_option':
			$recur_option = $val;
			break;
			case 'recur_stime':
			$recur_stime = $val;
			break;
			case 'recur_etime':
			$recur_etime = $val;
			break;
			case 'logintime':
			$logintime = $val;
			break;
			case 'session_limit':
			$session_limit = $val;
			break;
			case 'max_time':{
				$max_time = $val;
			}
			break;
			default:
		}
	}
	
	$remainTimeInSec = -1;

    // Obtain number of seconds left before expiry date
    if (isset($expiryDate) && $expiryDate != '') {
		$remainTimeInSec = strtotime($expiryDate) - time();
    }
    
    if (isset($recur_option) && $recur_option == 1 && isset($recur_stime) && isset($recur_etime)) {
		list($hr, $Min) = split(":", $recur_stime);
		$tempTime1 = mktime($hr, $Min, 0, date("m"), date("d"), date("Y"));

		list($hr, $Min) = split(":", $recur_etime);
		$tempTime2 = mktime($hr, $Min, 0, date("m"), date("d"), date("Y"));

		if ($tempTime2 < $tempTime1) {
			$tempTime2 += 86400;
		}
		
		// Obtain number of seconds left before recurring end time
		$tempTime2 = $tempTime2 - time();

		// 1st comparsion, update value with the sooner(smaller) one
		if ($remainTimeInSec >= 0) {
			if ($remainTimeInSec > $tempTime2) {
			$remainTimeInSec = $tempTime2;
			}
		} else {
			$remainTimeInSec = $tempTime2;
		}
    }

    // timeleft (not edit or calculate before)
	if (isset($max_time) && strlen( $max_time > 0 ) && $max_time >= 0 && isset($logintime)) {
		$timeLeftInSec = ($max_time* 60) - (time()-$logintime);
		if ($remainTimeInSec >= 0) {
			if ($timeLeftInSec < $remainTimeInSec ) {
				$remainTimeInSec = $timeLeftInSec;
			}
		} else {
			$remainTimeInSec = $timeLeftInSec;
		}
	}

	// session limit
	if (isset($session_limit) && strlen( $session_limit > 0 ) && $session_limit >= 0 && isset($logintime) ) {
		$sessionLimitInSec = ($session_limit* 60) - (time()-$logintime);
		if ($remainTimeInSec >= 0) {
			if ($sessionLimitInSec < $remainTimeInSec ) {
				$remainTimeInSec = $sessionLimitInSec;
			}
		} else {
			$remainTimeInSec = $sessionLimitInSec;
		}
	}
	
	return $remainTimeInSec;	
}

?>
