<?php

// 20080415 - Add notice about layout modifications
/*
 * Please refer to
 * "FirstSpot\authserv\template\login_form_body.tpl"
 * for HTML layout content
 */

require_once "fs_login.php";
require_once 'generate_common.php';

// 20080401 - Collect dynamic HTML content for layout
$smarty->assign('L_LOGIN_FORM_TITLE', get_var('greeting'));
$smarty->assign('L_LOGIN_FORM_CHARSET', metaCharset());
$smarty->assign('L_LOGIN_FORM_LANG_BOX', language_selection_box()); // generate a selection box for user to choose language
if ($html != '>') {
    $smarty->assign('L_LOGIN_FORM_PIC_LINK', "<a href=\"$html\">");
} else {
    $smarty->assign('L_LOGIN_FORM_PIC_LINK', '');
}
$smarty->assign('LOGIN_FORM_PIC', $pic);
$smarty->assign('LOGIN_FORM_PIC_ALT', get_var('login_form_pic_alt'));
$cSelfSignup = '';
if (isset($scratchLogin) && strtolower($scratchLogin) == 'on') {
    $smarty->assign('L_LOGIN_FORM_USER_NAME', get_var('user_scratch'));
    $smarty->assign('L_LOGIN_FORM_USERBOX_TYPE', 'password');
    $smarty->assign('L_LOGIN_FORM_SCRATCH_COMMENT_OPEN', '<!--');
    $smarty->assign('L_LOGIN_FORM_SCRATCH_COMMENT_CLOSE', '-->');
} else {
    $smarty->assign('L_LOGIN_FORM_USER_NAME', get_var('user_name'));
    $smarty->assign('L_LOGIN_FORM_USERBOX_TYPE', 'text');
    $smarty->assign('L_LOGIN_FORM_SCRATCH_COMMENT_OPEN', '');
    $smarty->assign('L_LOGIN_FORM_SCRATCH_COMMENT_CLOSE', '');
    if (isset($displaySelfSignup) && strtolower($displaySelfSignup) == 'on') {
	$cSelfSignup = '<a class="signuplink" href="signup_form.php">'.get_var('sign_up_now').'</a>';
    }
}
$smarty->assign('L_LOGIN_FORM_SELF_SIGN_UP', $cSelfSignup);
$smarty->assign('L_LOGIN_FORM_PASSWORD', get_var('Password'));
$smarty->assign('LOGIN_FORM_SUBMIT_BTN', get_var('submit_btn'));
if (isset($sLoginRemind)) {
    if ($sLoginRemind == '') {
	$smarty->assign('L_LOGIN_FORM_REMIND_COMMENT_OPEN', '<!--');
	$smarty->assign('L_LOGIN_FORM_REMIND_COMMENT_CLOSE', '-->');
    } else {
	$smarty->assign('L_LOGIN_FORM_REMIND_COMMENT_OPEN', '');
	$smarty->assign('L_LOGIN_FORM_REMIND_COMMENT_CLOSE', '');
    }
    $smarty->assign('L_LOGIN_FORM_REMIND', $sLoginRemind);
} else {
    $smarty->assign('L_LOGIN_FORM_REMIND', '');
    $smarty->assign('L_LOGIN_FORM_REMIND_COMMENT_OPEN', '<!--');
    $smarty->assign('L_LOGIN_FORM_REMIND_COMMENT_CLOSE', '-->');
}

// 20090921 - Temp modification in v6, mod TPL in the next version
if (isset($disable_show_example) && $disable_show_example == 1) {
	$smarty->assign('L_LOGIN_FORM_EXAMPLE', '');
} else {
	$smarty->assign('L_LOGIN_FORM_EXAMPLE', get_var('example'));
}

$smarty->assign('L_LOGIN_FORM_SUPPORT_LINK', print_support_link('login'));
$smarty->assign('L_LOGIN_FORM_FREE_WEBSITE', get_var('free_website'));
if (isset($sLoginLink)) {
    if (count($sLoginLink) <= 0) {
	$smarty->assign('L_LOGIN_FORM_LINK_COMMENT_OPEN', '<!--');
	$smarty->assign('L_LOGIN_FORM_LINK_COMMENT_CLOSE', '-->');
	$smarty->assign('L_LOGIN_FORM_LINK', '');
    } else {
	$smarty->assign('L_LOGIN_FORM_LINK_COMMENT_OPEN', '');
	$smarty->assign('L_LOGIN_FORM_LINK_COMMENT_CLOSE', '');
	$cLoginLink = '';
	$i = 0;
	while ($i < count($sLoginLink)) {
	    if (isset($sLoginLink[$i][0]) && isset($sLoginLink[$i][1])) {
		$cLoginLink .= '
			<tr><td><a class="freelink" href="'.$sLoginLink[$i][1].'">'.$sLoginLink[$i][0].'</a></td></tr>';
	    } else {
		$cLoginLink .= '
			<tr><td><br></td></tr>';
	    }
	    $i++;
	}
	$smarty->assign('L_LOGIN_FORM_LINK', $cLoginLink);
    }
} else {
    $smarty->assign('L_LOGIN_FORM_LINK_COMMENT_OPEN', '<!--');
    $smarty->assign('L_LOGIN_FORM_LINK_COMMENT_CLOSE', '-->');
    $smarty->assign('L_LOGIN_FORM_LINK', '');
}
$smarty->assign('L_LOGIN_FORM_TERM_TITLE', get_var('term_condition'));
if (isset($sLoginTerm)) {
    if ($sLoginTerm == '') {
	$smarty->assign('L_LOGIN_FORM_TERM_COMMENT_OPEN', '<!--');
	$smarty->assign('L_LOGIN_FORM_TERM_COMMENT_CLOSE', '-->');
    } else {
	$smarty->assign('L_LOGIN_FORM_TERM_COMMENT_OPEN', '');
	$smarty->assign('L_LOGIN_FORM_TERM_COMMENT_CLOSE', '');
    }
    $smarty->assign('L_LOGIN_FORM_TERM_CONTENT', $sLoginTerm);
} else {
    $smarty->assign('L_LOGIN_FORM_TERM_COMMENT_OPEN', '<!--');
    $smarty->assign('L_LOGIN_FORM_TERM_COMMENT_CLOSE', '-->');
    $smarty->assign('L_LOGIN_FORM_TERM_CONTENT', '');
}
$smarty->assign('L_LOGIN_FORM_TECH_BY', get_var('login_form_tech_by'));

// 20080707 - Add new tag to pass redirect information
$sOkUrl = '';
if (isset($sslRedir)) {
    $sOkUrl = "?&sslredir=$sslRedir";
} elseif (isset($loginPage)) {
    $sOkUrl = "?&loginPage=$loginPage";
}
$smarty->assign('LOGIN_FORM_OKURL', $sOkUrl);

// variable <p_result> init by generate_common.php
$l_meta="";
$l_body="";
if($p_result == 1){
	// workaround for add meta tag (purpose: set width = device width, scale = 1, <work in wm6.5 >) inside head tag through J_COMMON
	$l_meta.='<META content="width=device-width,minimum-scale=1.0,maximum-scale=1.0" name=viewport>';
	$j_common.=$l_meta;
	
	// workaround for window.onload <fs_login.php> not work in some mobile device (wm6.1.0 or previous version)
	$l_body='onload=fillName()';
	$smarty->assign('L_LOGIN_FORM_BODY', $l_body);
	
}

$smarty->assign('J_COMMON', $j_common);

// 20080331 - Move layout content and include the file here
if (isset($enableRedir) && $enableRedir == 1) {
    $smarty->display($redirTpl);
} else {
    $smarty->display('login_form_body.tpl');
}

?>
