<?php
// no cache for browser
header('Cache-Control: no-cache, must-revalidate');
require_once "cmvar.php";
include_once "apache.php";
include_once "timezone.php";

$printHead = true;

// 20090602 - Print error in message window before FirstSpotCore starts
function PrintErr($errMsg)
{
	global $printHead;

	$timeStr = date('D M d H:i:s Y');
	$fp = fopen("..\\log\\error.log", "a");
	if ($fp) {
		if ($printHead) {
			fwrite($fp, "$timeStr\t***** All the error messages of session started at $timeStr are shown below *****\r\n");
			$printHead = false;
		}
		fwrite($fp, "$timeStr\t$errMsg\r\n");
		fclose($fp);
	}
}

// 20090602 - Phase message according to different error code
function ErrCodeToMsg($code)
{
	define('HKEY_LOCAL_MACHINE', 0x80000002);

	$computer = '.';
	$reg = new COM("winmgmts:{impersonationLevel=impersonate}!\\\\$computer\\root\\default:StdRegProv");
	$regStr = '';

	$keyPath = 'SYSTEM\CurrentControlSet\Services\DispatcherService';
	$varValue = new VARIANT();
	$reg->GetMultiStringValue(HKEY_LOCAL_MACHINE, $keyPath, 'DependOnService', $varValue);
	$reg = null;

	foreach ($varValue as $value) {
		if ($value != 'firsthop') {
			if (strlen($regStr) > 0) {
				$regStr .= ', '.$value;
			} else {
				$regStr .= $value;
			}
		}
	}
	
	switch ((int)$code) {
	case 1056:
		// ERROR_SERVICE_ALREADY_RUNNING, do not print this
		break;
	case 1068:
		// ERROR_SERVICE_DEPENDENCY_FAIL
		PrintErr("Visitor Network Interface Card did not bind the PatronSoft FirstHop Driver, or some of the following services failed to start: $regStr.");
		break;
	case 1075:
		// ERROR_SERVICE_DEPENDENCY_DELETED
		PrintErr("FirstHop driver or some of the following services ($regStr) could be missing. Please check your installation. As a last resort, please uninstall and reinstall FirstSpot.");
		break;
	default:
		PrintErr("Check Win32 System Error Code $code.");
	}
}

// create COM Object
$settingobj = new COM('FSCONFIG.Cfgmgr') or die('setstatus.php FSCONFIG.Cfgmgr Object cannot be created!');

// 20090518 - Remove Start
$version = $settingobj->getKey('version', 'version');
    if (substr_count(strtolower($version), 'standard') > 0) {
        if (substr_count(strtolower($version),'donation')>0)
            $version = substr($version,0,strlen($version)-9);
        $disabled = ' disabled';
    } else {
        $disabled = '';
    }

$fsfo_mode = $settingobj->getKey( 'mode', 'FSFO'); 

if (!isset($_SESSION['fs_reduce'])||$_SESSION['fs_reduce']=='')
    $_SESSION['fs_reduce'] = 0;
if (!isset($_SESSION['fs_standby'])||$_SESSION['fs_standby']=='')
    $_SESSION['fs_standby'] = 0;

$connectionMBu="";
    
if ($fsfo_mode == 1 || $fsfo_mode == 2){
	// Check connection between Main and Backup
	$connectionMBu = $settingobj->QueryConnectionMBu();
}
    
if (isset($_GET['wakeup']) && $_GET['wakeup'] == 0 ){//&& $connectionMBu == "Connect" ){
	$wakeup = $settingobj->NotifyCallWakeUp();

	// 20090428 - Decrease refresh times
	$_SESSION['updatetimeplus'] = 0; // make some refresh when click "wake up" 
}

if (!isset($_SESSION['button'])||$_SESSION['button']=='')
    $_SESSION['button'] = 'done';

if( $_SESSION['button']=='done' ) {
	$_SESSION['fs_status'] = $settingobj->queryService();
	
	/*
	$loopCount = 60;
    while ($_SESSION['fs_status'] == "STARTING" || $loopCount <= 0) {
		$_SESSION['fs_status'] = $settingobj->queryService();
		$loopCount--;
    }
    */
}
// start is clicked
else if($_SESSION['button']=='START') {
	$_SESSION['PrintErr'] = 'false';
    if($_SESSION['fs_status']=='STARTING') {
        $_SESSION['button'] = 'done';

		// 20090602 - Print error message if fail to start service
		$rsult = $settingobj->startService();
		if (strlen($rsult) > 0) {
			ErrCodeToMsg($rsult);
		}
    } else
        $_SESSION['fs_status'] = 'STARTING';

	// 20090428 - Initialize on every start
	$_SESSION['fs_reduce'] = 0;
}
// stop is clicked
else if ($_SESSION['button']=='STOP') {
    if($_SESSION['fs_status']=='STOPPING') {
        $_SESSION['button'] = 'done';
        $rsult = $settingobj->stopService();
    } else
        $_SESSION['fs_status'] = 'STOPPING';
}
// restart is clicked
else if ($_SESSION['button']=='RESTART') {
    if($_SESSION['fs_status']=='STOPPING') {
        $_SESSION['button'] = 'RESTART_STOPPED';
        $rsult = $settingobj->stopService();
    } else
        $_SESSION['fs_status'] = 'STOPPING';
} else if ($_SESSION['button']=='RESTART_STOPPED') {
    if($_SESSION['fs_status']=='STARTING') {
        $_SESSION['button'] = 'done';

		// 20090602 - Print error message if fail to start service
		$rsult = $settingobj->startService();
		if (strlen($rsult) > 0) {
			ErrCodeToMsg($rsult);
		}
    } else
        $_SESSION['fs_status'] = 'STARTING';

	// 20090428 - Initialize on every start
	$_SESSION['fs_reduce'] = 0;
}

// release COM Object
//$settingobj->Release();
$settingobj=null;

//IMPORTANT: Please DO NOT change the refresh value below
//There will be memory leak when using IE to open the Config Manager,
//so that we do not update status once after Firstspot started successfully.
//Such problem does not exist on Firefox nor mozilla.

if (!isset($_SESSION['updatetimeplus']))
		$_SESSION['updatetimeplus'] =-1;

// 20090428 - Refresh once to update mode after STARTED is enough
if ($_SESSION['fs_status'] != 'STARTED' && $_SESSION['fs_status'] != 'STOPPED') {
	$updatetime = '1';
	if ($_SESSION['updatetimeplus'] != 0) {
		$_SESSION['updatetimeplus'] = 0;
	}
} elseif ($_SESSION['fs_status'] == 'STARTED' && isset($_SESSION['updatetimeplus']) && $_SESSION['updatetimeplus'] < 1 && $_SESSION['updatetimeplus'] != -1) {
	$updatetime = '1';
	$_SESSION['updatetimeplus']++;
} else {
	$_SESSION['updatetimeplus'] = -1;
	$updatetime = '-600';
}

if (isset($_SESSION['laststatus'])&&($_SESSION['laststatus']=='STARTING')&&($_SESSION['fs_status']=='STOPPED')&&(file_exists("..\\log\\error.log"))) {
    $_SESSION['error'] = 'true';
    $_SESSION['errorlog'] = '';
    $_SESSION['laststatus'] = $_SESSION['fs_status'];
} else if (($_SESSION['laststatus']=='STARTING')&&($_SESSION['fs_status']=='STARTED')) {
    $_SESSION['message'] = 'FirstSpot&reg; has started successfully.';
    $_SESSION['error'] = 'startsuccess';
    $_SESSION['errorlog'] = '';
    $_SESSION['laststatus'] = $_SESSION['fs_status'];
} else if (($_SESSION['laststatus']=='STOPPED')&&($_SESSION['fs_status']=='STARTING')) {
    $_SESSION['message'] = 'Starting FirstSpot&reg;. Please Wait...<br>Save button disabled during the starting of service.';
    $_SESSION['error'] = 'starting';
    $_SESSION['errorlog'] = '';
    $_SESSION['laststatus'] = $_SESSION['fs_status'];
} else if (($_SESSION['laststatus']=='STOPPING')&&($_SESSION['fs_status']=='STOPPED')) {
	if (!isset($_SESSION['PrintErr']) || $_SESSION['PrintErr'] != 'true'){
    $_SESSION['message'] = 'FirstSpot&reg; has stopped successfully.';
    $_SESSION['error'] = 'stopsuccess';
    $_SESSION['errorlog'] = '';
    $_SESSION['laststatus'] = $_SESSION['fs_status'];
  }else {
	  $_SESSION['error'] = 'true';
    $_SESSION['errorlog'] = '';
    $_SESSION['laststatus'] = $_SESSION['fs_status'];
  }
} else if ((($_SESSION['laststatus'] =='STARTED')&&($_SESSION['fs_status']=='STOPPING') &&(file_exists("..\\log\\error.log")))) {
	// checking have any error print (by stop FS)
	$settingobj = new COM('FSCONFIG.Cfgmgr') or die('setstatus.php FSCONFIG.Cfgmgr Object cannot be created!');
	if ($settingobj->QueryPrintStopErr() == 'PrintErr'){
    $_SESSION['PrintErr'] = 'true';
  }
  $settingobj=null;
} else if 	(($_SESSION['laststatus'] =='STARTING')&&($_SESSION['fs_status']=='STOPPING') &&(file_exists("..\\log\\error.log"))) {
    $_SESSION['PrintErr'] = 'true';
} else {
    $error='false';
}

if ( isset($_SESSION['fs_status'])&&(($_SESSION['fs_status']=='STARTING')||($_SESSION['fs_status']=='STOPPING')) ){
    $_SESSION['laststatus'] = $_SESSION['fs_status'];
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>FirstSpot Configuration Manager Status</title>
<meta http-equiv="refresh" content="<?= $updatetime ?> ; URL=setstatus.php" >
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<base target="_self">
<style type="text/css"><!--
    h1 { font-family: sans-serif; font-size:10pt; font-weight:bold; color:#006633; }
    h2 { font-family: sans-serif; font-size:14pt; font-weight:bold; }
-->
</style>
<script type="text/javascript">
<!--
function disable(state,err){
    var oStartButton = parent.document.getElementById('startbutton');
    var oStopButton = parent.document.getElementById('stopbutton');
    var oRestartButton = parent.document.getElementById('restartbutton');
    var oSaveButton = parent.parent.mid_right_top.document.getElementById('save_button');
    if ((err=="true")||(err=="startsuccess")||(err=="stopsuccess")||(err=="starting")) {
	    parent.parent.mid_right_bottom.location.reload();
    }

    if ( (state!='STARTED') && (state!='STOPPED') ) {
        oStartButton.src="./images/startdim.gif";
        oStartButton.disabled=true;
        oStopButton.src="./images/stopdim.gif";
        oStopButton.disabled=true;
        oRestartButton.src="./images/restartdim.gif";
        oRestartButton.disabled=true;

        if (parent.parent.mid_right_top && oSaveButton) {
            oSaveButton.src="./images/save_dim.gif";
            oSaveButton.disabled=true;
        }
    } else {
        oStartButton.src="./images/start.gif";
        oStartButton.disabled=false;
        oStopButton.src="./images/stop.gif";
        oStopButton.disabled=false;
        oRestartButton.src="./images/restart.gif";
        oRestartButton.disabled=false;

        if (parent.parent.mid_right_top && oSaveButton) {
            oSaveButton.src="./images/save.gif";
            oSaveButton.disabled=false;
        }
    }
}
function warnReduceFunction()
{
    open('setReduceFunction.php','','toolbar=0,directories=0,status=0,menubar=0,scrollbars=0,resizable=0,width=520,height=320');
}
// -->
</script>
</head>

<?php

if ( ($_SESSION['rootlogin'] == 'true') || ($_SESSION['access_parameter']{0} == '1') ) {
    echo "<body ALINK=\"#FF0000\" VLINK=\"#0000FF\"  onload=\"disable('".$_SESSION['fs_status']."','".$_SESSION['error']."')\">\n";
} else {
    echo "<body>\n";
}

?>
<h1>FirstSpot Status :&nbsp;&nbsp;&nbsp;<input type="image" class="image" src="./images/refresh.png" onclick='javascript:location.reload();' title='refresh FirstSpot Status'></h1>
<?php
$settingobj = new COM('FSCONFIG.Cfgmgr') or die('setstatus.php FSCONFIG.Cfgmgr Object cannot be created!');

$status_color = '#05E';                         // STARTING & STOPPING
$rfmResult = array();
if ( $_SESSION['fs_status'] == 'STOPPED' ){      // STOPPED
    $status_color = '#FF4040';
    $_SESSION['fs_standby'] = 0;
}else if ( $_SESSION['fs_status'] == 'STARTED' ) // STARTED
{
	// 20090427 - Wait until mode result is received
	$verStr = $settingobj->getKey('version', 'version');
	while ($_SESSION['fs_reduce'] == 0 && substr_count(strtolower($verStr), 'trial') == 0) {
		sleep(2);
		$_SESSION['fs_reduce'] = $settingobj->checkReduceFuncMode();
	}
	$rfmResult = explode("|", $_SESSION['fs_reduce']);

	if ($fsfo_mode == 1 || $fsfo_mode == 2 || (isset($_SESSION['fs_standby']) && $_SESSION['fs_standby'] != 0))
    	$_SESSION['fs_standby'] = $settingobj->QueryStandby();
    
    $status_color = '#063';
}

echo "<h2 align=\"center\" style=\"color: $status_color;\">{$_SESSION['fs_status']}</h2>";

if (isset($rfmResult[0]) && $rfmResult[0] != 0 && $rfmResult[0] != 2 && $rfmResult[0] != "FSCoreStoppedEvent FOUND") {
    echo "<p align=\"center\" style=\"font-size:9pt; color: #030;\">".get_cm_var('setstatus_reduce_func')."<br>";
    echo "<a href='javascript:warnReduceFunction();' title='".get_cm_var('setstatus_reduce_func_why')."'>".get_cm_var('setstatus_reduce_func_why')."</a></p>";
}

if ($disabled !=' disabled' && $_SESSION['fs_status'] == 'STARTED' ) // STARTED
{
	if ($fsfo_mode == 3){ // using Load Balancing
		$curr_priority = -1;
	
		// Get priority state
		$curr_priority = $settingobj->QueryPriority();
		
		echo "<p align=\"center\" style=\"font-size:9pt; color: #030;\">".get_cm_var('setstatus_loadbalance');
		
		if ($curr_priority == 0){ // unknow
			echo "<br><span style=\"font-size:8pt; color: #030;\">".get_cm_var('setstatus_unknowpriority')."<span>";
		}else if ($curr_priority == 1){ // waiting assign priority
			echo "<br><span style=\"font-size:8pt; color: #030;\">".get_cm_var('setstatus_wait_assign_priority')."<span>";
		}else if ($curr_priority == 3){ // High Priority
			echo "<br><span style=\"font-size:8pt; color: #030;\">".get_cm_var('setstatus_highpriority')."<span>";
		}else if ($curr_priority == 4){ // Low Priority
			echo "<br><span style=\"font-size:8pt; color: #030;\">".get_cm_var('setstatus_lowpriority')."<span>";
		}else{
			echo "[Error]";
		}
		echo"<br></p>";
	} else if ($fsfo_mode == 1){ // Main Machine
		if(isset($_SESSION['fs_standby']) && $_SESSION['fs_standby'] == -1)
		{
			echo "<p align=\"center\" style=\"font-size:9pt; color: #030;\">".get_cm_var('setstatus_mainmachine');
				
		    if ($connectionMBu == "Connect"){
			    echo '<img class="image" src="./images/connect.gif"  title="Backup machine is available" width="15" height="15">';
			    echo "<br><span style=\"font-size:7pt; color: #030;\">".get_cm_var('setstatus_mainmachine_backup_available')."<span>";
		    } else{
		    	echo '<img class="image" src="./images/disconnect.gif"  title="Backup machine is not available" width="15" height="15">';
			    echo "<br><span style=\"font-size:7pt; color: #030;\">".get_cm_var('setstatus_mainmachine_backup_not_available')."<span>";
	    	}
		
		    echo"<br></p>";
		}	
	} else if ($fsfo_mode == 2){ // Backup Machine
		if(isset($_SESSION['fs_standby']) && $_SESSION['fs_standby'] == 1)
		{
			echo "<p align=\"center\" style=\"font-size:9pt; color: #030;\">".get_cm_var('setstatus_backupmachine');
				
		    if ($connectionMBu == "Connect"){
			    echo '<img class="image" src="./images/connect.gif"  title="Main machine is available" width="15" height="15">';
		    	echo "<br><span style=\"font-size:9pt; color: #030;\">".get_cm_var('setstatus_standby')."<span>"; 
			    echo "<br><span style=\"font-size:8pt; color: #030;\"><a href='setstatus.php?wakeup=0'>".get_cm_var('setstatus_wakeup')."</a><span>";
		    } else{
		    	echo '<img class="image" src="./images/disconnect.gif"  title="Main machine is not available" width="15" height="15">';
			    echo "<br><span style=\"font-size:7pt; color: #030;\">".get_cm_var('setstatus_backupmachine_main_not_available')."<span>";
	    	}
		
		    echo"<br></p>";
		}else if (isset($_SESSION['fs_standby']) && $_SESSION['fs_standby'] == -1){
			echo "<p align=\"center\" style=\"font-size:9pt; color: #030;\">".get_cm_var('setstatus_backupmachine');
			echo "<br><span style=\"font-size:8pt; color: #030;\">".get_cm_var('setstatus_takeover')."<span>";
			echo"<br></p>";
		}	
	}
}

$settingobj=null;
?>

</body>
</html>

